﻿using C1.WPF.Grid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace FlexgridContinuousSelection
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ObservableCollection<Customer> customers;
        public MainWindow()
        {
            InitializeComponent();
            customers = Customer.GetCustomerList(100);
            grid.ItemsSource = customers;
            grid.PreviewMouseDown += Grid_PreviewMouseDown;
        }

        private void Grid_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            if(Keyboard.Modifiers == ModifierKeys.Shift)
            {
                if (grid.SelectionMode == GridSelectionMode.CellRange)
                {
                    var ht = grid.HitTest(e);
                    if(ht!=null)
                    {
                        if(ht.CellType == GridCellType.Cell)
                        {
                            if (grid.CursorRange != null)
                            {
                                var r1 = grid.CursorRange.Row;
                                var c1 = grid.CursorRange.Column;
                                var r2 = ht.CellRange.Row;
                                var c2 = ht.CellRange.Column;

                                var row1 = r1;
                                var row2 = r2;
                                var col1 = c1;
                                var col2 = c2;
                                if(r1>r2)
                                {
                                    row1 = r2;
                                    row2 = r1;
                                }
                                if (c1 > c2)
                                {
                                    col1 = c2;
                                    col2 = c1;
                                }
                                grid.Selection = new GridCellRange(row1,col1,row2, col2);
                            }
                        }
                    }                    
                    e.Handled = true;
                }                
            }
        }
    }
}
